#include "AST.h"
#include "CodeContext.h"
#include "UniqueId.h"


UniqueId IterationNode::generator( "continue" );


IterationNode::IterationNode()
{
}


const string IterationNode::continueLabel() const
{
  if (_continueLabel.empty())
    _continueLabel = generator.next();
  
  return _continueLabel;
}
    


void IterationNode::emitContinueTarget( ostream &os ) const
{
  os << continueLabel() << ": ;" << endCline;
}


void IterationNode::unwindContinue( CodeContext &context, const TreeNode &destination ) const
{
  unwind( context );
    
  if (&destination == this)
    context << "goto " << continueLabel() << ";" << endCline;
  else
    parent()->unwindContinue( context, destination );
}
