#define __SINST__		// g++ header bug
#include "AST.h"
#include "MethodDecl.h"
#include "code-operator.h"


TypeNode *MethodDecl::thisType() const
{
  if (modifiers() & Common::Static)
    return 0;
  else
    {
      TypeNode * const global = container()->asType();
      return (!global->isImmutable() && (type()->isLocal() || (category() & Constructor)))
	? global->addModifiers( Common::Local )
	: global;
    }
}


////////////////////////////////////////////////////////////////////////


const string MethodDecl::cMethodNameDynamic() const
{
  string result = encodedMethodName(*name());

  if (category() != Constructor)
    {
      const TypeNode *self = thisType();
      if (self && self->isReference())
	{
	  result += '_';
	  if (methodType()->isLocalInferred())
	    result += 'I';
	  else if (self->isLocal())
	    result += 'L';
	  else
	    result += 'G';
	}
    }
  
  foriter (param, type()->paramTypes()->allTypes(), TreeNode::TypeIter)
    {
      result += '_';
      if ((*param)->isLocalInferred()) result += 'I';      
      result += (*param)->cType();
    }

  return result;
}


const string MethodDecl::cMethodNameStatic() const
{
  return container()->cType().name + cMethodNameDynamic();
}


const string Decl::cMethodNameDynamic() const
{
    invalidOperation( "cMethodNameDynamic" );
    return "";
}


const string Decl::cMethodNameStatic() const
{
    invalidOperation( "cMethodNameStatic" );
    return "";
}


////////////////////////////////////////////////////////////////////////


MethodDecl::MethodDecl( const string *name, TypeNode *type,
			Category _category, ClassDecl *classOrIntf,
			Modifiers mods, TreeNode *source )
  : MemberDecl( name, type, classOrIntf, mods, source ),
    _overrides( 0 ),
    _category( _category )
{
}


MethodTypeNode *MethodDecl::methodType() const
{
  TypeNode * const result = type();
  assert( result->kind() == Common::MethodKind );
  return static_cast< MethodTypeNode * >(result);
}
