#include "AST.h"
#include "CodeContext.h"
#include "CtType.h"
#include "string16.h"


const string StringLitNode::emitExpression2( CodeContext &context )
{
  const string temporary = declareTemporary( context );
  const char *length_string;

  context << "{" << endCline;
  if (text().length() == 0) {
    /* Empty string. This is handled separately because printEscaped()
       emits a series of jchars in C braces. Some C compilers balk if
       there is nothing in the braces.
       */
    context << "jchar chars[1];" << endCline;
    length_string = "0";
  } else {
    /* Non-empty string */
    context << "static jchar chars[] = ";
    printEscaped( context, text() );
    context << ";" << endCline;
    length_string = "sizeof(chars) / sizeof(*chars)";
  }
  context << " " << type()->cType()
	  << " string = java_string_build_16(" << length_string
	  << ", chars);" << endCline
	  << temporary << " = string;" << endCline << "}" << endCline;
    
  return temporary;
}
