#include <cassert>
#include "../compiler.h"
#include "../ClassDecl.h"
#include "../MemberDecl.h"
#include "CtClass.h"


CtClass::CtClass( const string &name, ClassDecl &basis )
  : CtStruct( name ),
    basis( basis )
{
  // Internal classes should never make it to code generation.  So if
  // you're asking for C type names relating to an internal class,
  // you're doing something wrong.
  
  assert( basis.container()->fullName() != "ti.internal" );
}


void CtClass::dependFields( CtRegistry &depends ) const
{
  dependHeaderFields( depends );
  dependMembers( basis, depends );
}


void CtClass::defineFields( ostream &out ) const
{
  defineHeaderFields( out );
  defineMembers( basis, out );
}


void CtClass::dependHeaderFields( CtRegistry & ) const
{
}


void CtClass::defineHeaderFields( ostream & ) const
{
}


void CtClass::dependMembers( ClassDecl &, CtRegistry & ) const
{
}


void CtClass::defineMembers( ClassDecl &, ostream & ) const
{
}


// Local Variables:
// c-file-style: "gnu"
// End:
