#include <cassert>
#include "../AST.h"
#include "../ClassDecl.h"
#include "CtDescriptor.h"
#include "CtObjectInstance.h"
#include "CtLocal.h"
#include "CtExternal.h"
#include "CtRegistry.h"


static const CtExternal monitor( "titanium_monitor_t" );
static const CtLocal monitorPtr( monitor );


CtObjectInstance::CtObjectInstance( ClassDecl &basis )
  : CtInstance( basis ),
    descriptor( basis.cDescriptorType() )
{
  assert( basis.asType()->isReference() );
}


void CtObjectInstance::dependHeaderFields( CtRegistry &depends ) const
{
  depends.add( descriptor );
  depends.add( monitorPtr );
  
  CtInstance::dependHeaderFields( depends );
}


void CtObjectInstance::defineHeaderFields( ostream &out ) const
{
  CtInstance::defineHeaderFields( out );
  
  out << descriptor << ' ' << "class_info;\n"
      << "void (**intf_info)();\n"
      << monitorPtr << ' ' << "monitor;\n";
}


// Local Variables:
// c-file-style: "gnu"
// End:
