#include "AST.h"
#include "CodeContext.h"


const string CandNode::emitExpression2( CodeContext &context )
{
  const string result = opnd0()->defineTemporary( context );
  context << "if (" << result << ") ";
  CodeContext secondContext( context );
  const string second = opnd1()->emitExpression( secondContext );
  secondContext << result << " = " << second << ";" << endCline;
  return result;
}


const string CorNode::emitExpression2( CodeContext &context )
{
  const string result = opnd0()->defineTemporary( context );
  context << "if (!" << result << ") ";
  CodeContext secondContext( context );
  const string second = opnd1()->emitExpression( secondContext );
  secondContext << result << " = " << second << ";" << endCline;
  return result;
}


const string IfExprNode::emitExpression2( CodeContext &context )
{
  const string cond = condition()->emitExpression( context );
  const string result = declareTemporary( context );

  context << "if (" << cond << ") ";
  {
    CodeContext thenContext( context );
	
    const string thenPart = thenOpnd()->emitExpression( thenContext );
    thenContext << result << " = " << thenPart << ";" << endCline;
  }
  context << "else ";
  {
    CodeContext elseContext( context );
    const string elsePart = elseOpnd()->emitExpression( elseContext );
    elseContext << result << " = " << elsePart << ";" << endCline;
  }

  return result;
}
