#define __SINST__		// g++ header bug
#include <map>
#include <string>
#include "code-operator.h"


typedef pair< const string, string > Pair;

static const Pair Table[] = {
  Pair( "!", "logicalComplement" ),
  Pair( "~", "bitwiseComplement" ),
  Pair( "<", "less" ),
  Pair( ">", "greater" ),
  Pair( "<=", "lessEqual" ),
  Pair( ">=", "greaterEqual" ),
  Pair( "==", "equality" ),
  Pair( "!=", "inequality" ),
  Pair( "+", "addition" ),
  Pair( "-", "subtraction" ),
  Pair( "*", "multiplication" ),
  Pair( "/", "division" ),
  Pair( "&", "bitwiseAnd" ),
  Pair( "|", "bitwiseOr" ),
  Pair( "^", "bitwiseXor" ),
  Pair( "%", "remainder" ),
  Pair( "<<", "leftShift" ),
  Pair( ">>", "signedRightShift" ),
  Pair( ">>>", "unsignedRightShift" ),
  Pair( "+=", "additionAssign" ),
  Pair( "-=", "subtractionAssign" ),
  Pair( "*=", "multiplicationAssign" ),
  Pair( "/=", "divisionAssign" ),
  Pair( "%=", "remainderAssign" ),
  Pair( "<<=", "leftShiftAssign" ),
  Pair( ">>=", "signedRightShiftAssign" ),
  Pair( ">>>=", "unsignedRightShiftAssign" ),
  Pair( "&=", "bitwiseAndAssign" ),
  Pair( "^=", "bitwiseXorAssign" ),
  Pair( "|=", "bitwiseOrAssign" ),
  Pair( "[]", "arrayAccess" ),
  Pair( "[]=", "arrayAccessAssign" )
};

enum { TableCount = sizeof( Table ) / sizeof( *Table ) };

typedef map< string, string, less< string > > Map;
static const Map Translation( &Table[ 0 ], &Table[ TableCount ] );


const string encodedMethodName( const string &sourceName )
{
  // It would be simpler to look up *every* name in the translation
  // table, but for speed we want to short-circuit the common case.
  
  if (isalpha( sourceName[ 0 ] )
      || sourceName[ 0 ] == '_'
      || sourceName[ 0 ] == '$')
    return "_mt_" + sourceName;
  
  else {
    const Map::const_iterator lookup = Translation.find( sourceName );
    assert( lookup != Translation.end() );
    return "_op_" + (*lookup).second;
  }
}
