#define __SINST__		// g++ header bug
#include <iostream>
#include <iterator>
#include "ClassDecl.h"
#include "FieldDecl.h"
#include "MethodDecl.h"
#include "PrimitiveDecl.h"
#include "decls.h"


void dump( ostream &sink, unsigned, const Decl * value )
{
  value->dump( sink );
}


void Decl::dump( ostream &sink ) const
{
  sink << '<' << thisClassName() << ' ' << this;
  dumpAttributes( sink );
  sink << '>';
}


void PackageDecl::dumpAttributes( ostream & ) const
{
}


void ClassDecl::dumpAttributes( ostream &sink ) const
{
  sink << ' ' << source();
}


void LocalVarDecl::dumpAttributes( ostream &sink ) const
{
  sink << ' ' << source();
}


void FormalParameterDecl::dumpAttributes( ostream &sink ) const
{
  sink << ' ' << source();
}


void FieldDecl::dumpAttributes( ostream &sink ) const
{
  sink << ' ' << source();
}


void MethodDecl::dumpAttributes( ostream &sink ) const
{
  sink << ' ' << source()
       << ' ' << overrides()
       << " { ";
  
  ostream_iterator< MethodDecl * > showImpls( sink, " " );
  copy( implements().begin(), implements().end(), showImpls );
  
  sink << '}';
}


void StmtLblDecl::dumpAttributes( ostream &sink ) const
{
  sink << ' ' << source();
}


void PrimitiveDecl::dumpAttributes( ostream &sink ) const
{
}
