#include <set>
#include "AST.h"
#include "bane-var.h"
#include "solver.h"


set< const TreeNode * > LocalBaneVar::known;


LocalBaneVar::LocalBaneVar()
  : node( 0 )
{
}


LocalBaneVar::LocalBaneVar( const TreeNode &node )
  : node( &node )
{
  known.insert( &node );
}


const TreeNode &LocalBaneVar::toNode() const
{
  return *node;
}


ostream & operator << ( ostream &sink, const LocalBaneVar &var )
{
  unsigned long address = reinterpret_cast< unsigned long >( var.node );
  assert( sizeof( address ) >= sizeof( var.node ) );
  return sink << '\'' << address << ":t";
}


istream & operator >> ( istream &source, LocalBaneVar &var )
{
  const set< const TreeNode * > &known = LocalBaneVar::known;

  if (source.get() == '\'')
    {
      unsigned long address;
      source >> address;
      const TypeNode * const node = reinterpret_cast< const TypeNode * >( address );
      if( known.find( node ) != known.end() )
	{
	  var.node = node;
	  return source;
	}
    }
  source.set( ios::failbit );
}
