#include "AST.h"
#include "enact-context.h"


bool TreeNode::localEnactBits( const LocalEnactContext &context,
			       Modifiers &modifiers ) const
{
  const LocalSolution &solution = context.solution;
  const LocalSolution::const_iterator find = solution.find( this );
  const LocalBound bound = find == solution.end() ? BoundLocal : find->second;
  const bool wasLocal = modifiers & Local;
  bool changed;

  if (wasLocal && bound == BoundGlobal)
    {
      error( "local inference removed explicit locality qualification" );
      (int &) modifiers &= ~Local;
      changed = true;
    }
  else if (!wasLocal && bound == BoundLocal)
    {
      (int &) modifiers |= Local | LocalInferred;
      changed = true;
    }
  else
    changed = false;

  context.stats.record( changed );
  return changed;
}
