#ifndef _INCLUDE_TITANIUM_LOCAL_ENACT_CONTEXT_H_
#define _INCLUDE_TITANIUM_LOCAL_ENACT_CONTEXT_H_


#include <iosfwd>
#include "solution.h"
#include "stats-map.h"

class LocalStats;
class PackageDecl;


class LocalEnactContext {
public:
  LocalEnactContext( const LocalSolution & );
  LocalEnactContext( const LocalEnactContext &, const bool & );
  LocalEnactContext( const LocalEnactContext &, PackageDecl * );

  const LocalSolution &solution;
  const bool * const thisLocal;
  LocalStats &stats;

  static void printStats( ostream & );

private:
  static void printStat( ostream &, PackageDecl *, const LocalStats & );
  static LocalStatsMap statsMap;
};


#endif // !_INCLUDE_TITANIUM_LOCAL_ENACT_CONTEXT_H_
