#include "AST.h"
#include "decls.h"


void TreeNode::unshareTypeTree()
{
  foriter (child, allChildren(), ChildIter)
    (*child)->unshareTypeTree();
  
  unshareType();
}


////////////////////////////////////////////////////////////////////////


void CastNode::unshareType()
{
  dtype( dtype()->deepCloneType() );
  type( dtype() );
}


void ConstructorDeclNode::unshareType()
{
  TypeNode &declType = *decl()->type();

  TypeListNode &paramTypes = *declType.paramTypes();  
  for (unsigned sweep = params()->arity(); sweep--; )
    paramTypes.child( sweep, params()->child( sweep )->dtype() );
}


void DataDeclNode::unshareType()
{
  dtype( dtype()->deepCloneType() );
  decl()->type( dtype() );
}


void ExprNode::unshareType()
{
  type( type()->deepCloneType() );
}


void InstanceOfNode::unshareType()
{
  ExprNode::unshareType();
  dtype( dtype()->deepCloneType() );
}


void MethodNode::unshareType()
{
  TypeNode &declType = *decl()->type();

  returnType( returnType()->deepCloneType() );
  declType.returnType( returnType() );

  TypeListNode &paramTypes = *declType.paramTypes();  
  for (unsigned sweep = params()->arity(); sweep--; )
    paramTypes.child( sweep, params()->child( sweep )->dtype() );
}


void ParameterNode::unshareType()
{
  dtype( dtype()->deepCloneType() );
  decl()->type( dtype() );
}


void TreeNode::unshareType()
{
}
