#ifndef _include_deref_h_
#define _include_deref_h_

#include <gp-trace/gp-trace.h>
#include "libsplit-c.h"


#define DEREF_GLOBAL(result, ptr)			\
  do {							\
    gp_trace_event( "deref", isLocal(ptr) );		\
							\
    if (isLocal(ptr))					\
      result = *(ptr).addr;				\
    else {						\
      const ___globPtrType sc = scPtr(ptr);		\
							\
      switch (sizeof(result)) {				\
      case 1:						\
	*((char *) &result) = __c_read(sc);		\
	break;						\
      case 2:						\
	*((short *) &result) = __sh_read(sc);		\
	break;						\
      case 4:						\
	*((int *) &result) = __i_read(sc);		\
	break;						\
      case 8:						\
	*((long long *) &result) = __ll_read(sc);	\
	break;						\
      default:						\
	bulk_read(&result, sc, sizeof(result));		\
      }							\
    }							\
  } while (0)


#endif /* !_include_deref_h_ */
