#include "java_array.h"
#include "java_string.h"
#include "native-stubs.h"
#include "titanium.h"

#include "cl_ti_lang_NativeUtils.h"
#include "layout!JA_GP_cl_java_lang_String.h"
#include "layout!JA_jbyte.h"


char * globalJstringToCstring( GP_JString string )
{
  const LP_JA_jbyte bytes =
    cl_ti_lang_NativeUtils_mt_getBytes_GP_cl_java_lang_String( string );
  
  const int length = bytes->header.length; 
  char * const result = ti_malloc( length + 1 );
  
  memcpy( result, &bytes->data, length );
  result[ length ] = 0;
  return result;
}


char * localJstringToCstring( LP_JString localString )
{
  GP_JString string;
  globalize( string, localString );
  return globalJstringToCstring( string );
}


LP_JString java_string_build_16( int length, jchar literal[] )
{
    LP_JString result;
    LP_JA_jchar array;

    JAVA_ARRAY_BUILD( array, length, literal );
    result = cl_ti_lang_NativeUtils_mt_buildString_LP_JA_jchar( array );
    
    return result;
}


LP_JString java_string_build_8( char literal[] )
{
    const int length = strlen( literal );
    LP_JString result;
    LP_JA_jbyte array;
    
    JAVA_ARRAY_BUILD( array, length, (jbyte *) literal );    
    result = cl_ti_lang_NativeUtils_mt_buildString_LP_JA_jbyte( array );
    
    return result;
}


GP_JA_GP_cl_java_lang_String java_strings_build( int argc, char *argv[] )
{
    JA_GP_cl_java_lang_String *strings;
    JAVA_ARRAY_ALLOC( strings, NULL, argc, GP_JString );

    while (argc--) {
	LP_JString newbie = java_string_build_8( argv[ argc ] );
	globalize( strings->data[argc], newbie );
    }

    {
	GP_JA_GP_cl_java_lang_String result;
	globalize( result, strings );
	return result;
    }
}
