#include "file-64.h"		/* must appear before fcntl & unistd */

#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include "exceptions.h"
#include "gc.h"
#include "java_string.h"
#include "mem-local.h"
#include "native-file-utils.h"
#include "native-utils.h"

#include "cl_ti_lang_NativeUtils.h"
#include "layout!GP_cl_java_io_FileDescriptor.h"
#include "layout!cl_java_io_FileDescriptor.h"
#include "layout!GP_jint.h"


void jclose( const GP_cl_java_io_FileDescriptor descriptor )
{
    GP_jint fdPtr;
    int fd;
    
    CHECK_NULL_GLOBAL( descriptor );
    
    FIELD_ADDR_GLOBAL( fdPtr, descriptor, cl_java_io_FileDescriptor_fld_fd );
    DEREF_GLOBAL( fd, fdPtr );
    
    if (close( fd ))
	tossIOException();
}


void jopen( const GP_cl_java_io_FileDescriptor descriptor,
	    const GP_JString name, int flags )
{
    const char *bytes;
    int fd;
    
    CHECK_NULL_GLOBAL( descriptor );
    
    bytes = globalJstringToCstring( name );
    fd = open64( bytes, flags | O_LARGEFILE,
		 S_IRUSR | S_IWUSR |
		 S_IRGRP | S_IWGRP |
		 S_IROTH | S_IWOTH );
    
    if (fd == -1)
	tossIOException();
    else {
	GP_jint field;
	FIELD_ADDR_GLOBAL( field, descriptor, cl_java_io_FileDescriptor_fld_fd );
	ASSIGN_GLOBAL( field, fd );
    }
}


void tossIOException()
{
    char * const ascii = strerror( errno );
    const LP_JString message = java_string_build_8( ascii );
    cl_ti_lang_NativeUtils_mt_throwIOException_LP_cl_java_lang_String( message );

    abort();			/* should never be reached */
}

void tossIOException_str(char * const ascii)
{

    const LP_JString message = java_string_build_8( ascii );
    cl_ti_lang_NativeUtils_mt_throwIOException_LP_cl_java_lang_String( message );
    
    abort();			/* should never be reached */
}

