#include <stdlib.h>
#include "fp-utils.h"
#include "gc.h"
#include "java_array.h"
#include "linkage.h"
#include "native-str-utils.h"

#include "cl_java_lang_NumberFormatException.h"
#include "layout!GP_cl_java_lang_NumberFormatException.h"
#include "cl_java_lang_String.h"
#include "layout!GP_cl_java_lang_String.h"


typedef    cl_java_lang_NumberFormatException    NumExcept;
typedef GP_cl_java_lang_NumberFormatException GP_NumExcept;


void tossNumberFormatException( GP_JString message )
{
  NumExcept * const newbie = (NumExcept *) ti_malloc( sizeof( NumExcept ) );
  GP_NumExcept exception;
  
  cl_java_lang_NumberFormatException_mt_NumberFormatException_GP_cl_java_lang_String(
	newbie, message );

  globalize( exception, newbie );
  THROW( exception );
}


jdouble stringToDouble( GP_JString str )
{
  const jint length = cl_java_lang_String_mt_length_G( str );
  if (!length)
    tossNumberFormatException( str );
  else
    {
      const char * const begin = globalJstringToCstring( str );
      char *end;
      const jdouble result = strtod( begin, &end );

      if (end - begin == length)
	return result;
      else
	tossNumberFormatException( str );
    }
}


GP_cl_java_lang_String doubleToString( jdouble value )
{
    GP_cl_java_lang_String result;
    
    char buffer[ 32 ];
    g_fmt( buffer, value );
    
    globalize( result, java_string_build_8( buffer ) );
    return result;
}
