#include "gc.h"
#include "mem-local.h"
#include "native-utils.h"

#include "cl_java_lang_ArrayIndexOutOfBoundsException.h"
#include "cl_java_lang_NullPointerException.h"
#include "layout!GP_cl_java_lang_ArrayIndexOutOfBoundsException.h"
#include "layout!GP_cl_java_lang_NullPointerException.h"
#include "layout!cl_java_lang_ArrayIndexOutOfBoundsException.h"


typedef cl_java_lang_NullPointerException NullExcept;
typedef GP_cl_java_lang_NullPointerException GP_NullExcept;
typedef cl_java_lang_ArrayIndexOutOfBoundsException ArrayExcept;
typedef GP_cl_java_lang_ArrayIndexOutOfBoundsException GP_ArrayExcept;


void tossNullPointerException()
{
    GP_NullExcept exception;
    NullExcept * const newbie = (NullExcept *) ti_malloc( sizeof( NullExcept ) );
    cl_java_lang_NullPointerException_mt_NullPointerException( newbie );

    globalize( exception, newbie );
    THROW( exception );
}


void checkArrayBounds( jint trustedMax, jint offset, jint length )
{
    if (offset < 0 || length < 0 || offset + length > trustedMax) {
	GP_ArrayExcept exception;
	ArrayExcept * const newbie = (ArrayExcept *) ti_malloc( sizeof( ArrayExcept ) );
	cl_java_lang_ArrayIndexOutOfBoundsException_mt_ArrayIndexOutOfBoundsException( newbie );

	globalize( exception, newbie );
	THROW( exception );
    }
}
