#ifndef _INCLUDE_RUNTIME_OPTIONS_H_
#define _INCLUDE_RUNTIME_OPTIONS_H_

#include "config.h"

/* Inline modifier */
#if defined(USE_RUNTIME_INLINE) && !defined(FORCE_NO_RUNTIME_INLINE)
#  define INLINE_MODIFIER inline
#else /* USE_RUNTIME_INLINE && !FORCE_NO_RUNTIME_INLINE */
#  define INLINE_MODIFIER
#endif /* USE_RUNTIME_INLINE && !FORCE_NO_RUNTIME_INLINE */

/* Variable size stack arrays */
#if defined(USE_RUNTIME_VARARRAY) && !defined(FORCE_NO_RUNTIME_VARARRAY)
#  define VARARRAY_DECLARE(type, var, size) type var[size]
#  define VARARRAY_CREATE(type, var, size) ((void) 0)
#  define VARARRAY_DESTROY(var) ((void) 0)
#else /* USE_RUNTIME_VARARRAY && !FORCE_NO_RUNTIME_VARARRAY */
#  include "ti-gc.h"
#  define VARARRAY_DECLARE(type, var, size) type * var
#  define VARARRAY_CREATE(type, var, size) var = (type *) ti_malloc(sizeof(type)*(size))
#  define VARARRAY_DESTROY(var) ((void) 0)
#endif /* USE_RUNTIME_VARARRAY && !FORCE_NO_RUNTIME_VARARRAY */

#endif /* _INCLUDE_RUNTIME_OPTIONS_H_ */
