#ifndef __THREAD_CTL_H__
#define __THREAD_CTL_H__

#include <ti-memory.h>

#if defined(BACKEND_SMP_NARROW) || defined(BACKEND_SMP_WIDE)
#include <thread.h>
#include "linkage.h"

/********************************************************************************
 *
 * data types
 *
 ********************************************************************************/

typedef struct ThreadControl {
    int				tc_procs;
    long			tc_flags;
    thread_t			*tc_threadInfo;
} ThreadControl_t;

typedef struct ThreadBarrier {
    int			tb_curr;
    int			tb_goal;
    
    mutex_t		tb_lock;
    volatile int	done;
} ThreadBarrier_t;



/********************************************************************************
 *
 * prototypes
 *
 ********************************************************************************/

EXTERN_C_BEGIN

void Thread_Init();
int Thread_Bind(int proc);
ThreadControl_t * Thread_CreateWorkers(int procs, void *(*func)(void *), void *arg[],long flags);
void Thread_DeleteWorkers(ThreadControl_t *t);
void Thread_Wait(ThreadControl_t *t);
void Thread_Barrier(ThreadBarrier_t *b, int id);
ThreadBarrier_t * Thread_BarrierInit(int goal);
void Thread_BarrierFini(ThreadBarrier_t *b);

EXTERN_C_END


#else /* not SMP */


typedef void ThreadBarrier_t;


#endif /* not SMP */
#endif /* __THREAD_CTL_H__ */
