#ifndef __ti_thread_h
#define __ti_thread_h

#include <ti-memory.h>
#ifdef MEMORY_SHARED

#include <threads.h>
#include "monitor.h"

typedef struct _titanium_thread_t {
  ti_thread_t tid;
  /* cl_java_lang_Thread *jthread; */
  titanium_monitor_t *locked_monitors;
  int alivep;
  int runningp;
  int priority;
  int dienowp;
  int processor;
  struct ThreadBarrier_t *barrier;
  void(*_run)();
} titanium_thread_t;

typedef struct _titanium_thread_list {
  titanium_thread_t *thread;
  struct _titanium_thread_list *cdr;
} titanium_thread_list;

titanium_thread_t *find_thread_by_id(ti_thread_t tid);
void thread_cons_monitor(ti_thread_t tid, titanium_monitor_t *monitor);
void thread_remove_monitor(ti_thread_t tid, titanium_monitor_t *monitor);

#endif /* MEMORY_SHARED */
#endif
