// WARNING: This file is automatically generated.
// Uses faked templates.  Replace 3 with specified.

package ti.domains;

//
// ========================
// Multi Rect Domain Type A
// ========================
//
// This represents a domain that is a list of Rect Domains.  It
// is optimized for a fast "foreach" at the expense of set comparisons
// and operations.
//

public class tiMultiRectADomain3 extends tiDomain3 {

  // Constructors
  public tiMultiRectADomain3() {
    rects = new tiRectDomainList3();
  }
  public tiMultiRectADomain3(tiRectDomainList3 rectList) {
    rects = rectList;
  }
  public tiMultiRectADomain3(tiRectDomain3 rd) {
    rects = new tiRectDomainList3();
    if (!rd.isNull()) {
      rects.append(rd);
    }
  }

  // Internal set relations routines
  private tiRectDomainList3 newSubtract(tiRectDomainList3 dl) {
    tiRectDomainList3 result = rects;

    for (tiRectDomainListIterator3 d_iter = dl.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      tiRectDomainList3 saved_result = result;
      result = new tiRectDomainList3();
      for (tiRectDomainListIterator3 iter = saved_result.newIterator();
	   !iter.isEnd();
	   iter.advance()) {

	tiRectDomain3 id =
	  iter.dereference().multiply(d_iter.dereference());

	if (id.isNull()) {
	  result.append(iter.dereference());
	} else if (id.isEqual(iter.dereference())) {
	  // do nothing
	} else {
	  tiRectDomain3 rd = iter.dereference();
	  Point<3> p0 = rd.getLowerBound();
	  Point<3> p1 = rd.getUpperBound();
	  Point<3> stride = rd.getStride();

	  // slice
	  for (int i = 0; i < rd.getArity(); i++) {
	    int rd_p0 = p0.get(i);
	    int rd_p1 = p1.get(i);
	    int id_p0 = id.getLowerBound().get(i);
	    int id_p1 = id.getUpperBound().get(i);

	    if (rd_p0 < id_p0) {
	      result.append(new tiRectDomain3(p0,
						    p1.set(i, id_p0),
						    stride));
	      p0 = p0.set(i, id_p0);
	    }
	    if (rd_p1 > id_p1) {
	      result.append(new tiRectDomain3(p0.set(i,
							   (id_p1 -
							    1 +
							    stride.get(i))),
						    p1,
						    stride));
	      p1 = p1.set(i, id_p1);
	    }
	  }

	  // handle interior of overlap
	  for (int i = 0; i < rd.getArity(); i++) {
	    if (stride.get(i) < id.getStride().get(i)) {
	      for (int set_p0 = p0.get(i);
		   set_p0 < (p1.get(i) -
			     id.getStride().get(i));
		   set_p0 += id.getStride().get(i)) {
		result.
		  append(new tiRectDomain3(p0.set(i,
							(set_p0 +
							 stride.get(i))),
						 p1.set(i,
							(set_p0 +
							 id.
							 getStride().
							 get(i))),
						 stride));
	      }
	      stride = stride.set(i,
				  id.getStride().get(i));
	    }
	  }
	}
      }
    }

    return result;
  }

  // Set Relations
  public tiDomain3 add(tiDomain3 d) {
    tiRectDomainList3 mdl = d.getRectangles();
    tiRectDomainList3 result = newSubtract(mdl);

    for (tiRectDomainListIterator3 d_iter = mdl.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      result.append(d_iter.dereference());
    }

    return new tiMultiRectADomain3(result);
  }
  public tiDomain3 difference(tiDomain3 d) {
    tiRectDomainList3 mdl = d.getRectangles();

    return new tiMultiRectADomain3(newSubtract(mdl));
  }
  public tiDomain3 multiply(tiDomain3 d) {
    // this * d

    tiRectDomainList3 result = new tiRectDomainList3();
    tiRectDomainList3 mdl = d.getRectangles();

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      for (tiRectDomainListIterator3 d_iter = mdl.newIterator();
	   !d_iter.isEnd();
	   d_iter.advance()) {

	tiRectDomain3 partial_result =
	  iter.dereference().multiply(d_iter.dereference());

	if (!partial_result.isNull()) {
	  result.append(partial_result);
	}
      }
    }

    return new tiMultiRectADomain3(result);
  }
  public boolean isNull() {
    // this is null

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      if (!iter.dereference().isNull()) {
	return false;
      }
    }
    return true;
  }
  public boolean isEqual(tiDomain3 d) {
    // this == d
    return (isSubset(d) && d.isSubset(this));
  }
  public boolean isNotEqual(tiDomain3 d) {
    return (!isSubset(d) || !d.isSubset(this));
  }
  public boolean isSubset(tiDomain3 d) {
    // this <= d
    tiRectDomainList3 mdl = d.getRectangles();
    return newSubtract(mdl).isEmpty();
  }
  public boolean isStrictSubset(tiDomain3 d) {
    // this < d
    return isSubset(d) && (!d.isSubset(this));
  }
  public boolean isSuperset(tiDomain3 d) {
    return d.isSubset(this);
  }
  public boolean isStrictSuperset(tiDomain3 d) {
    return d.isStrictSubset(this);
  }

  // RectDomain Relations
  public tiDomain3 add(tiRectDomain3 rd) {
    return add(new tiMultiRectADomain3(rd));
  }
  public tiDomain3 difference(tiRectDomain3 rd) {
    return difference(new tiMultiRectADomain3(rd));
  }
  public tiDomain3 multiply(tiRectDomain3 rd) {
    return multiply(new tiMultiRectADomain3(rd));
  }

  public boolean isEqual(tiRectDomain3 rd) {
    return isEqual(new tiMultiRectADomain3(rd));
  }
  public boolean isNotEqual(tiRectDomain3 rd) {
    return isNotEqual(new tiMultiRectADomain3(rd));
  }
  public boolean isSubset(tiRectDomain3 rd) {
    return isSubset(new tiMultiRectADomain3(rd));
  }
  public boolean isStrictSubset(tiRectDomain3 rd) {
    return isStrictSubset(new tiMultiRectADomain3(rd));
  }
  public boolean isSuperset(tiRectDomain3 rd) {
    return isSuperset(new tiMultiRectADomain3(rd));
  }
  public boolean isStrictSuperset(tiRectDomain3 rd) {
    return isStrictSuperset(new tiMultiRectADomain3(rd));
  }

  // Point Relations
  public tiDomain3 add(Point<3> p) {
    // this + p
    tiRectDomainList3 result = new tiRectDomainList3();

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().add(p));
    }

    return new tiMultiRectADomain3(result);
  }
  public tiDomain3 difference(Point<3> p) {
    // this - p
    tiRectDomainList3 result = new tiRectDomainList3();

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().difference(p));
    }

    return new tiMultiRectADomain3(result);
  }
  public tiDomain3 divide(Point<3> p) {
    // this / p
    tiDomain3 result = new tiMultiRectADomain3();

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      // Call the add function to remove any overlaps generated by rounding
      // effects during the divide.
      result = result.add(iter.dereference().divide(p));
    }

    return result;
  }
  public tiDomain3 multiply(Point<3> p) {
    // this * p
    tiRectDomainList3 result = new tiRectDomainList3();

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().multiply(p));
    }

    return new tiMultiRectADomain3(result);
  }

  public tiDomain3 permute(Point<3> p) {
    tiRectDomainList3 result = new tiRectDomainList3();

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().permute(p));
    }

    return new tiMultiRectADomain3(result);
  }

  // Shape Information
  public boolean doesContain(Point<3> p) {
    // this contains p

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      if (iter.dereference().doesContain(p)) {
	return true;
      }
    }
    return false;
  }
  public boolean isRectangular() {
    joinRectangles();

    return rects.hasSingularity();
  }
  public int getNumPoints() {
    int result = 0;

    for (tiRectDomainListIterator3 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result = result + iter.dereference().getNumPoints();
    }

    return result;
  }
  public Point<3> getLowerBound() {
    Point<3> result;
    tiRectDomainListIterator3 iter = rects.newIterator();

    if (iter.isEnd()) {
      return Point<3>.all(0);
    } else {
      result = iter.dereference().getLowerBound();
      for (iter.advance();
	   !iter.isEnd();
	   iter.advance()) {
	result = result.getLowerBound(iter.dereference().getLowerBound());
      }
      return result;
    }
  }
  public Point<3> getUpperBound() {
    Point<3> result;
    tiRectDomainListIterator3 iter = rects.newIterator();

    if (iter.isEnd()) {
      return Point<3>.all(0);
    } else {
      result = iter.dereference().getUpperBound();
      for (iter.advance();
	   !iter.isEnd();
	   iter.advance()) {
	result = result.getUpperBound(iter.dereference().getUpperBound());
      }
      return result;
    }
  }
  public Point<3> getUpperMaxPoint() {
    return getUpperBound().sub(Point<3>.all(1));
  }
  public tiRectDomain3 getBoundingBox() {
    return new tiRectDomain3(getLowerBound(),
				   getUpperBound(),
				   Point<3>.all(1));
  }
  public tiRectDomainList3 getRectangles() {
    return rects;
  }

  // Internal dynamic optimization routines
  private void joinRectangles() {
    boolean changes_made;
    tiRectDomainList3 currList = rects;

    do {
      changes_made = false;
      tiRectDomainList3 newList = new tiRectDomainList3();
      boolean ignore[] = new boolean[currList.getNumItems()];

      for (int i = 0; i < currList.getNumItems(); i++) {
	ignore[i] = false;
      }

      int searchIndexInit = 0;
      for (tiRectDomainListIterator3 iter_x = currList.newIterator();
	   !iter_x.isEnd();
	   iter_x.advance()) {
	if (!ignore[searchIndexInit]) {
	  int searchIndex = searchIndexInit + 1;
	  boolean matchFound = false;
	  for (tiRectDomainListIterator3 iter_comp_x =
		 currList.newIterator(iter_x).advance();
	       ((!iter_comp_x.isEnd()) && (!matchFound));
	       iter_comp_x.advance()) {
	    if (!ignore[searchIndex]) {
	      tiDomain3 result =
		iter_x.dereference().add(iter_comp_x.dereference());
	      tiRectDomainList3 rdl = result.getRectangles();
	      if (rdl.hasSingularity()) {
		tiRectDomain3 rd = rdl.getSingularity();

		newList.append(rd);
		changes_made = true;
		matchFound = true;
		ignore[searchIndex] = true;
	      }
	    }
	    searchIndex++;
	  }
	  if (!matchFound) {
	    newList.append(iter_x.dereference());
	  }
	}
	searchIndexInit++;
      }
      currList = newList;
    } while (changes_made);
    rects = currList;
  }

  // Dynamic optimizations
  public tiDomain3 demote() {
    joinRectangles();

    return this;
  }

  // Convert to a string
  public String toString() {
    String result;
    boolean isFirst;

    isFirst = true;
    result = "";
    for (tiRectDomainListIterator3 d_iter = rects.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      if (!isFirst) {
	result = result + " + ";
      }
      result = result + d_iter.dereference().toString();
      isFirst = false;
    }

    return result;
  }

  // Debugging
  /*
  public void print(String desc) {
    int count = 0;
    for (tiRectDomainListIterator3 d_iter = rects.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      count++;
      tiRectDomain3 rd = d_iter.dereference();
      Point<3> p = rd.getLowerBound();
      System.out.print(desc);
      System.out.print("(");
      System.out.print(count);
      System.out.print(") [[");
      for (int i = 0; i < p.arity(); i++) {
	if (i != 0) System.out.print(",");
	System.out.print(p.get(i));
      }
      System.out.print("] : ");
      Point<3> p2 = rd.getUpperBound();
      System.out.print("[");
      for (int i = 0; i < p2.arity(); i++) {
	if (i != 0) System.out.print(",");
	System.out.print(p2.get(i));
      }
      System.out.print("] : ");
      Point<3> p3 = rd.getStride();
      System.out.print("[");
      for (int i = 0; i < p3.arity(); i++) {
	if (i != 0) System.out.print(",");
	System.out.print(p3.get(i));
      }
      System.out.println("]]");
    }
  }
  */

  // State
  private tiRectDomainList3 rects;

}
